' generates WR commands to customize its function generator (can be invoked by F7, or by typing function name)
' script assumes that each of function has explanation before and takes line that begins with "# PURPOSE:"
' and function definition starts with "public function"
Public strScriptPath

Call main   ' invoke function, to have exit possibility from script using exit sub

Sub main()
    strScriptPath = InputBox("Input script name", "Script Directory", "..\ABC_Functions")
    category = mid(strScriptPath ,4)
    If strScriptPath = "" Then
        MsgBox "Script was canceled", vbInformation
        Exit Sub
    End If
    
    path_parts = Split(strScriptPath, "\")
    output_file = InputBox("Output file name", "Files to store", "function_generator_commands.txt")
    If output_file = "" Then
        MsgBox "Script was canceled", vbInformation
        Exit Sub
    End If
    
    file_name = "script"
    Set fso = CreateObject("Scripting.FileSystemObject")        ' Create a FileSystemObject.
    
    Set DirFiles = fso.OpenTextFile(strScriptPath & "\" & file_name)
    Set DirFilet = fso.OpenTextFile(output_file, 2, True)
    DirFilet.WriteLine chr(9) & "generator_add_category(" & chr(34) & category & chr(34) & ");"
    Do While Not (DirFiles.atEndOfStream)
        Line = DirFiles.ReadLine
        If Left(Line, 9) = "# PURPOSE" Then
            purpose = Mid(Line, 12)
            purpose=Replace(purpose,chr(34),"\" & chr(34))
        End If 
        If Left(Line, 14) = "# RETURN VALUE" Then ret_value = Mid(Line, 16)
        If Left(Line, 15) = "public function" Then
            op_br = instr(17,Line,"(")
            cl_br = instr(17,Line,")")
            funct = Replace(Mid(Line, 17,op_br-17), " ", "")                 ' get function name and args
            parami=""
            params = Mid(Line, op_br+1,cl_br-op_br-1)
            params = Replace(params, "inout ", "")
            params = Replace(params, "out ", "")		
            params = Replace(params, "in ", "")	
            params = Replace(params, " ", "")	
            parama = Split(params, ",")	
            paramc=Ubound(parama)
            paramc = paramc + 1
            for each i in parama
                parami = parami & "," & chr(34) & i & chr(34) & "," & chr(34) & "type_edit" & chr(34) & "," & chr(34) & chr(34)
            next
            defLine = chr(9) & "generator_add_function(" & chr(34) & funct & chr(34) & "," & chr(34) & purpose & chr(34) & ","
            defLine = defLine & paramc & parami & ");"
            addLine = chr(9) & "generator_add_function_to_category(" & chr(34) & category & chr(34) & "," & chr(34) & funct & chr(34) & ");"
        DirFilet.WriteLine defLine
        DirFilet.WriteLine addLine
        End If
    Loop
    
    MsgBox "Function generator code is stored in file:" & output_file, vbInformation, "Function list is ready"
    DirFiles.Close   ' Close file
    DirFilet.Close
End Sub

