' generates list of functions from WinRunner script file
' script assumes that each of function has explanation before and takes line that begins with "# PURPOSE:"
' and function definition starts with "public function"
Public strScriptPath

Call main   ' invoke function, to have exit possibility from scrit using exit sub

Sub main()
    strScriptPath = InputBox("Input script name", "Script Directory", "..\ABC_Functions")
    If strScriptPath = "" Then
        MsgBox "Script was canceled", vbInformation
        Exit Sub
    End If
    
    path_parts = Split(strScriptPath, "\")
    output_file = InputBox("Output file name", "Files to store", path_parts(UBound(path_parts)) & "_function_list.txt")
    If output_file = "" Then
        MsgBox "Script was canceled", vbInformation
        Exit Sub
    End If
    
    file_name = "script"
    Set fso = CreateObject("Scripting.FileSystemObject")        ' Create a FileSystemObject.
    
    Set DirFiles = fso.OpenTextFile(strScriptPath & "\" & file_name)
    Set DirFilet = fso.OpenTextFile(output_file, 2, True)
    Do While Not (DirFiles.atEndOfStream)
        Line = DirFiles.ReadLine
        If Left(Line, 9) = "# PURPOSE" Then purpose = Mid(Line, 11)
        If Left(Line, 14) = "# RETURN VALUE" Then ret_value = Mid(Line, 16)
        If Left(Line, 15) = "public function" Then
            funct = Replace(Mid(Line, 17), "{", "")                 ' get function name and args
            LineOut = Replace(funct & Chr(9) & "#" & purpose & "; " & ret_value, "  ", " ")
        DirFilet.WriteLine LineOut
        End If
    Loop
    
    MsgBox "List is stored in file:" & output_file, vbInformation, "Function list is ready"
    DirFiles.Close   ' Close file
    DirFilet.Close
End Sub

